// DEMO13_1.CPP - constant velocity demo
// to compile make sure to include DDRAW.LIB, DSOUND.LIB,
// DINPUT.LIB, WINMM.LIB, and of course the T3DLIB files

// INCLUDES ///////////////////////////////////////////////
//
#define INITGUID

#define WIN32_LEAN_AND_MEAN  

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream> // include important C/C++ stuff
#include <sstream>
#include <string>
#include <vector>
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>

#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>
#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"
using namespace std;

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINXCLASS"  // class name

#define WINDOW_WIDTH    320   // size of window
#define WINDOW_HEIGHT   240
#define NUM_HOTDOGS    4   // number of hotdogs out there


//Icon and cursor stuff
#include "source1.h";

// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL);
int Game_Shutdown(void *parms=NULL);
int Game_Main(void *parms=NULL);
int gameStartUp(int gameState);
void endGameScreen();

// GLOBALS ////////////////////////////////////////////////

HWND main_window_handle           = NULL; // save the window handle
HINSTANCE main_instance           = NULL; // save the instance
char buffer[80];                          // used to print text
int gameState = 0;						  // traverse screens

BITMAP_IMAGE background_bmp;   // holds the background
BITMAP_IMAGE intro1_bmp;      
BITMAP_IMAGE intro2_bmp;          
BITMAP_IMAGE title_bmp;           
BITMAP_IMAGE lukej_bmp;           
BITMAP_IMAGE producers_bmp;      
BITMAP_IMAGE credits_bmp;  
BITMAP_IMAGE endgameL_bmp;
BITMAP_IMAGE endgameW_bmp;
BITMAP_IMAGE instructions_bmp;
	  
//BOB          hotdog[NUM_HOTDOGS];  // the dogs
vector<BOB>	hotdog;
vector<BOB> availableCondies;
vector< vector<BOB> > condies;
vector< vector<int> > condiesInt;
vector< vector<BOB> > condiesAttached;
vector< vector<int> > condiesAttachedInt;
vector<int> baseCondiesInt;

BOB	mainHotDog;
BOB mainCondie;

int song_id;     

// general sound

// Gameplay related
int numOfCondies = 2;  // always desired number + 1; enter 6 MAX
int dogSpeed = 2;
int speedLevel = 1;
float score = 0.00;
int numServed = 1;
bool loser = false;

// Keeps track of where the hotdogs are on the screen //
int visibleDogs = 1;
int dogsOnScreen = 4;
int deletingDog = -1;
int deletingSprite = 0;


string debug =""; 

// Cursor info //
int curCur = 101;

// FUNCTIONS //////////////////////////////////////////////

void calculateLevel()
{
// 4 dogs fit on a screen at a time
// Users should get a screens worth of gameplay for each level of 
// condies

// The user should get x number of screen per speed, where x
// increments each time
	
	if(numServed%2 == 0)
	{
		if(numOfCondies <7) numOfCondies++;
	}

	int numNeededDogs;
	if(speedLevel > 3) numNeededDogs += 3;
	else numNeededDogs = 7;

	if(numServed%numNeededDogs == 0)
	{
		dogSpeed++;
	}
}

void calculateScore(int index)
{
	float base = 1;
	int wrongNumCondies = 0;
	int rightNumCondies = 0;
	debug = "";

	for(int i=0; i<condiesInt[index].size(); i++)
	{	
		int curWrong = 0;

		if(condiesInt[index][i] > condiesAttachedInt[index][i]) rightNumCondies += condiesAttachedInt[index][i];
		else rightNumCondies += condiesInt[index][i];

		curWrong = condiesInt[index][i] - condiesAttachedInt[index][i];	
		if(curWrong < 0) curWrong *= -1;

		wrongNumCondies += curWrong;

	}

	if(wrongNumCondies == 0) base += 0.2;
	base += 0.15*float(rightNumCondies) - .10*float(wrongNumCondies);
	if(base < 0.50) base = 0.50;

	score += base;

	if(wrongNumCondies == 1) 
	{
		score = score + -1.00;
	}
	else if(wrongNumCondies == 2)
	{
		score = score + -2.00;
	}
	else if(wrongNumCondies > 2) 
	{
		score = score + -3.00;
	}
}

string Convert (float number)
{    
	string toReturn;
	stringstream buff;     
	buff<< number;
	buff >> toReturn;
	return toReturn;
}
void attachCondie(BOB currentCondie, int mouse_x, int mouse_y, int index)
{
	Set_Vel_BOB(&currentCondie, dogSpeed, 0);
	Set_Pos_BOB(&currentCondie, mouse_x, mouse_y);
	currentCondie.varsI[0] = 26;
	currentCondie.varsI[1] = 34;
	condiesAttached[index].push_back(currentCondie);

}


LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT	ps;		   // used in WM_PAINT
HDC			hdc;	   // handle to a device context

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
		return(0);
		} break;

    case WM_PAINT:
         {
         // start painting
         hdc = BeginPaint(hwnd,&ps);

         // end painting
         EndPaint(hwnd,&ps);
         return(0);
        } break;

	case WM_DESTROY: 
		{
		// kill the application			
		PostQuitMessage(0);
		return(0);
		} break;


	case WM_LBUTTONUP:
		{

		 // Set the current mouse cursor
		 HCURSOR htomato = LoadCursor(main_instance, MAKEINTRESOURCE(curCur));
		SetCursor(htomato);

		}break;

	case WM_LBUTTONDOWN:
		{
			
		 // get the position of the mouse
         int mouse_x = (int)LOWORD(lparam);
         int mouse_y = (int)HIWORD(lparam);

		 // Check if the mouse is over a bin
		 // if so, change the icon accordingly

		 /*
			Mouse locations for each bin given in the following form
			(x,y) Upper Left
			(x,y) Bottom Right

			Bin 1/Relish:
			(9,21) UL
			(86, 120) BR

			Bin 2/Onions:
			(123,18)
			(201,120)

			Bin 3/Tomatos:
			(233, 18)
			(312, 121)

			Bin 4/Peppers:
			(353, 2)
			(421, 116)

			Bin 5/Bacon:
			(12, 164)
			(81, 260)

			Bin 6/Cheese:
			(126, 167)
			(197, 259)

			Bin 7/Sauerkraut:
			(238, 162)
			(307, 259)

			Bin 8/Pickles:
			(346, 165)
			(421, 259)

			Conveyor Belt:
			(5, 368)
			(546, 594)


		 */


			// Check if they are clicking on condiments
			if(mouse_x > 9 && mouse_x < 86 && mouse_y > 21 && mouse_y < 120) curCur = CURSOR_RELISH; //on the relish
			else if(mouse_x > 123 && mouse_x < 201 && mouse_y > 18 && mouse_y < 120) curCur = CURSOR_ONIONS; // on the onion
			else if(mouse_x > 223 && mouse_x < 312 && mouse_y > 18 && mouse_y < 121) curCur = CURSOR_TOMATO;
			else if(mouse_x > 353 && mouse_x < 421 && mouse_y > 2 && mouse_y < 116) curCur = CURSOR_PEPPERS;
			else if(mouse_x > 12 && mouse_x < 81 && mouse_y > 164 && mouse_y < 260) curCur = CURSOR_BACON;
			else if(mouse_x > 126 && mouse_x < 197 && mouse_y > 167 && mouse_y < 259) curCur = CURSOR_CHEESE;
			else if(mouse_x > 238 && mouse_x < 307 && mouse_y > 162 && mouse_y < 259) curCur = CURSOR_SAUERKRAUT;
			else if(mouse_x > 346 && mouse_x < 421 && mouse_y > 165 && mouse_y < 259) curCur = CURSOR_PICKLES;

			// Check if they are clicking on the tinfoal or random places
			else if(mouse_x > 478 && mouse_x < 554 && mouse_y > 204 && mouse_y < 252) curCur = CURSOR_TINFOIL; // on tin foil
			
			// Check if they clicked somewhere that isn't special.  If so, give them the default cursor
			else if (!(mouse_x > 5 && mouse_x < 546 && mouse_y > 368 && mouse_y < 594)) curCur = CURSOR_DEFAULT; // Not on the conveyor
			
			// Check if they are clicking on a hotdog
			else
			// If they are in here, they clicked somewhere in the conveyor belt
			{
				// Are they clicking on a dog?
				for (int index=0; index < hotdog.size(); index++)
				{
					int dogPosX = hotdog[index].x;
					int dogPosY = hotdog[index].y;

					if(mouse_x > dogPosX && mouse_x < (dogPosX + 260) && mouse_y > dogPosY && mouse_y < (dogPosY + 70)) 
					{	
							BOB currentCondie;
						
							switch(curCur)
							{
							case CURSOR_TINFOIL:
								deletingDog = index;
								curCur = CURSOR_DEFAULT;
								calculateScore(index);
								break;

							case CURSOR_TOMATO:
								Clone_BOB(&availableCondies[curCur], &currentCondie);
								attachCondie(currentCondie, mouse_x, mouse_y, index);
								condiesAttachedInt[index][curCur]++;
								break;

							case CURSOR_BACON:
								Clone_BOB(&availableCondies[curCur], &currentCondie);
								attachCondie(currentCondie, mouse_x, mouse_y, index);
								condiesAttachedInt[index][curCur]++;
								break;
							case CURSOR_CHEESE:
								Clone_BOB(&availableCondies[curCur], &currentCondie);
								attachCondie(currentCondie, mouse_x, mouse_y, index);
								condiesAttachedInt[index][curCur]++;
								break;

							case CURSOR_ONIONS:
								Clone_BOB(&availableCondies[curCur], &currentCondie);
								attachCondie(currentCondie, mouse_x, mouse_y, index);
								condiesAttachedInt[index][curCur]++;
								break;
							case CURSOR_PEPPERS:
								Clone_BOB(&availableCondies[curCur], &currentCondie);
								attachCondie(currentCondie, mouse_x, mouse_y, index);
								condiesAttachedInt[index][curCur]++;
								break;
							case CURSOR_PICKLES:
								Clone_BOB(&availableCondies[curCur], &currentCondie);
								attachCondie(currentCondie, mouse_x, mouse_y, index);
								condiesAttachedInt[index][curCur]++;
								break;
							case CURSOR_RELISH:
								Clone_BOB(&availableCondies[0], &currentCondie);
								attachCondie(currentCondie, mouse_x, mouse_y, index);
								condiesAttachedInt[index][0]++;
								break;
							case CURSOR_SAUERKRAUT:
								Clone_BOB(&availableCondies[curCur], &currentCondie);
								attachCondie(currentCondie, mouse_x, mouse_y, index);
								condiesAttachedInt[index][curCur]++;
								break;
							}
							
						break;
					}
				}

			}
			

		 // tell windows you handled it
		 return(0);


		}break;

	case WM_MOUSEMOVE:
         {
         // get the position of the mouse
         int mouse_x = (int)LOWORD(lparam);
         int mouse_y = (int)HIWORD(lparam);

		 HCURSOR htomato = LoadCursor(main_instance, MAKEINTRESOURCE(curCur));
		 SetCursor(htomato);


         } break;


	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

void deleteDog()
{
	if(deletingDog > -1)
	{
		// Delete all of the attached condiment BOBs before animating it
		// run this loop every time in case they try and add something after starting the
		// wrap
		for(int i=0; i<condiesAttached[deletingDog].size(); i++)
						Destroy_BOB(&condiesAttached[deletingDog][i]);

		if(deletingSprite < 8)
		{
			if(deletingSprite%3 == 0 && deletingSprite != 0) Animate_BOB(&hotdog[deletingDog]);
				deletingSprite++;
		}else{
			Destroy_BOB(&hotdog[deletingDog]);
			hotdog.erase(hotdog.begin() + deletingDog);
			
			// Delete all of the condiment BOBs
			for(int i=0; i<condies[deletingDog].size(); i++)
							Destroy_BOB(&condies[deletingDog][i]);

			condiesAttached.erase(condiesAttached.begin() + deletingDog);
			condiesAttachedInt.erase(condiesAttachedInt.begin() + deletingDog);
			condies.erase(condies.begin() + deletingDog);
			condiesInt.erase(condiesInt.begin() + deletingDog);

			deletingDog = -1;
			deletingSprite = 0;
		}
	}
}


void addNewHotdog()
{
	calculateLevel();
	if(hotdog.size() < dogsOnScreen)
	{
		numServed++;
		// Randomly make an order with a number of required condiments
		// as stipulated by the players level
		int randNumCondies = rand()%numOfCondies; 
		vector<BOB> currentCondies;
		vector<BOB> currentAttached;
		vector<int> currentCondiesInt = baseCondiesInt;
		//vector<int> baseInt = baseCondiesInt;
		BOB currentDog;
		Clone_BOB(&mainHotDog, &currentDog);
		


		for(int i=0; i<randNumCondies; i++)
		{
			BOB currentCondie;
		
			int randCondiment = 8; // pick one of available condiments;
			while(randCondiment == 8) randCondiment = rand()%availableCondies.size();
			Clone_BOB(&availableCondies[randCondiment], &currentCondie);

			// set new position and velocity for the condiments
			Set_Vel_BOB(&currentCondie, dogSpeed, 0);
			Set_Pos_BOB(&currentCondie, -280 + currentCondies.size()*28, 370);

			//float width  = 56 - 10 * currentCondies.size();
		    //float height = (float)width*((float)72/(float)56);

			currentCondie.varsI[0] = 26;
			currentCondie.varsI[1] = 34;
			
			//baseCondiesInt[1]++;
			currentCondiesInt[randCondiment]++;
			currentCondies.push_back(currentCondie);
		}

		// set new position and velocity for the dogs
		Set_Vel_BOB(&currentDog,dogSpeed,0);
		Set_Pos_BOB(&currentDog, -300, 400);

		

		// now here the tricky part, alter the size of the bob, but make sure
		// to keep the aspect ratio the same, so it doesn't look scrunched
		float width  = 200 - 10 * hotdog.size();
		float height = (float)width*((float)64/(float)200);

		// store new width and height in varsIable cache positions 0,1
		currentDog.varsI[0] = width;
		currentDog.varsI[1] = height;

		hotdog.push_back(currentDog);
		condiesAttached.push_back(currentAttached);
		condiesAttachedInt.push_back(baseCondiesInt);
		condies.push_back(currentCondies);
		condiesInt.push_back(currentCondiesInt);
	}
}

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{
// this is the winmain function

WNDCLASS winclass;	// this will hold the class we create
HWND	 hwnd;		// generic window handle
MSG		 msg;		// generic message
HDC      hdc;       // generic dc
PAINTSTRUCT ps;     // generic paintstruct

// first fill in the window class stucture
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
//winclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
winclass.hCursor		= LoadCursor(hinstance, MAKEINTRESOURCE(CURSOR_DEFAULT));
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL; 
winclass.lpszClassName	= WINDOW_CLASS_NAME;

// register the window class
if (!RegisterClass(&winclass))
	return(0);

// create the window, note the use of WS_POPUP
if (!(hwnd = CreateWindow(WINDOW_CLASS_NAME, // class
	"Wise Guys presents: The Hotdog Factory",	 // title
						  WS_POPUP | WS_VISIBLE,
					 	  0,0,	   // x,y
						  WINDOW_WIDTH,  // width
                          WINDOW_HEIGHT, // height
						  NULL,	   // handle to parent 
						  NULL,	   // handle to menu
						  hinstance,// instance
						  NULL)))	// creation parms
return(0);

// save the window handle and instance in a global
main_window_handle = hwnd;
main_instance      = hinstance;

// perform all game console specific initialization
Game_Init();

// enter main event loop
while(1)
	{
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{ 
		// test if this is a quit
        if (msg.message == WM_QUIT)
           break;
	
		// translate any accelerator keys
		TranslateMessage(&msg);

		// send the message to the window proc
		DispatchMessage(&msg);
		} // end if
    
    // main game processing goes here
    Game_Main();

	} // end while

// shutdown game and release all resources
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

// WIN T3D GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms)
{
// this function is where you do all the initialization 
// for your game

int index; // looping varsIable

char filename[80]; // used to build up filenames

// seed random number generate
srand(Start_Clock());

// start up DirectDraw (replace the parms as you desire)
DDraw_Init(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP);

// load background image
Load_Bitmap_File(&bitmap8bit, "screens/main_back_24.bmp");
Create_Bitmap(&background_bmp,0,0,640,480);
Load_Image_Bitmap(&background_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Set_Palette(bitmap8bit.palette);
Unload_Bitmap_File(&bitmap8bit);

//LOAD SPLASH IMAGE
Load_Bitmap_File(&bitmap8bit, "screens/credits.bmp");
Create_Bitmap(&credits_bmp,0,0,640,480);
Load_Image_Bitmap(&credits_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Set_Palette(bitmap8bit.palette);
Unload_Bitmap_File(&bitmap8bit);

//LOAD SPLASH IMAGE
Load_Bitmap_File(&bitmap8bit, "screens/lukej.bmp");
Set_Palette(bitmap8bit.palette);
Create_Bitmap(&lukej_bmp,0,0,640,480);
Load_Image_Bitmap(&lukej_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap8bit);

//LOAD TITLE SCREEN IMAGE
Load_Bitmap_File(&bitmap8bit, "screens/producers.bmp");
Set_Palette(bitmap8bit.palette);
Create_Bitmap(&producers_bmp,0,0,640,480);
Load_Image_Bitmap(&producers_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap8bit);

//LOAD BACKGROUND IMAGE
Load_Bitmap_File(&bitmap8bit, "screens/title.bmp");
Create_Bitmap(&title_bmp,0,0,640,480);
Load_Image_Bitmap(&title_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Set_Palette(bitmap8bit.palette);
Unload_Bitmap_File(&bitmap8bit);

//LOAD STORY IMAGE
Load_Bitmap_File(&bitmap8bit, "screens/intro1.bmp");
Create_Bitmap(&intro1_bmp,0,0,640,480);
Load_Image_Bitmap(&intro1_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Set_Palette(bitmap8bit.palette);
Unload_Bitmap_File(&bitmap8bit);

//LOAD END GAME IMAGE
Load_Bitmap_File(&bitmap8bit, "screens/intro2.bmp");
Create_Bitmap(&intro2_bmp,0,0,640,480);
Load_Image_Bitmap(&intro2_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Set_Palette(bitmap8bit.palette);
Unload_Bitmap_File(&bitmap8bit);

//LOAD END GAME IMAGE
Load_Bitmap_File(&bitmap8bit, "screens/endgame_lose.bmp");
Create_Bitmap(&endgameL_bmp,0,0,640,480);
Load_Image_Bitmap(&endgameL_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Set_Palette(bitmap8bit.palette);
Unload_Bitmap_File(&bitmap8bit);

//LOAD END GAME IMAGE
Load_Bitmap_File(&bitmap8bit, "screens/instructions.bmp");
Create_Bitmap(&instructions_bmp,0,0,640,480);
Load_Image_Bitmap(&instructions_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Set_Palette(bitmap8bit.palette);
Unload_Bitmap_File(&bitmap8bit);

Load_Bitmap_File(&bitmap8bit, "screens/endgame_win.bmp");
Create_Bitmap(&endgameW_bmp,0,0,640,480);
Load_Image_Bitmap(&endgameW_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Set_Palette(bitmap8bit.palette);
Unload_Bitmap_File(&bitmap8bit);




// Setup Hotdog BOBS
Load_Bitmap_File(&bitmap8bit, "screens/hotdog.bmp");
Create_BOB(&mainHotDog,0,120,200,64,3,BOB_ATTR_MULTI_FRAME | BOB_ATTR_VISIBLE, DDSCAPS_SYSTEMMEMORY);

for (index=0; index < 3; index++) // because there are 3 animation frames
    Load_Frame_BOB(&mainHotDog, &bitmap8bit, index, 0, index, BITMAP_EXTRACT_MODE_CELL);

//addNewHotdog();

Unload_Bitmap_File(&bitmap8bit);

// Setup Condiments BOBS
Load_Bitmap_File(&bitmap8bit, "screens/condies8.bmp");
Create_BOB(&mainCondie, 320, 400, 56, 72, 10, BOB_ATTR_MULTI_FRAME | BOB_ATTR_VISIBLE, DDSCAPS_SYSTEMMEMORY);

Load_Frame_BOB(&mainCondie, &bitmap8bit, 0, 0, 0, BITMAP_EXTRACT_MODE_CELL);
Load_Frame_BOB(&mainCondie, &bitmap8bit, 1, 1, 0, BITMAP_EXTRACT_MODE_CELL);
Load_Frame_BOB(&mainCondie, &bitmap8bit, 2, 2, 0, BITMAP_EXTRACT_MODE_CELL);
Load_Frame_BOB(&mainCondie, &bitmap8bit, 3, 3, 0, BITMAP_EXTRACT_MODE_CELL);
Load_Frame_BOB(&mainCondie, &bitmap8bit, 4, 4, 0, BITMAP_EXTRACT_MODE_CELL);
Load_Frame_BOB(&mainCondie, &bitmap8bit, 5, 0, 1, BITMAP_EXTRACT_MODE_CELL);
Load_Frame_BOB(&mainCondie, &bitmap8bit, 6, 1, 1, BITMAP_EXTRACT_MODE_CELL);
Load_Frame_BOB(&mainCondie, &bitmap8bit, 7, 2, 1, BITMAP_EXTRACT_MODE_CELL);
Load_Frame_BOB(&mainCondie, &bitmap8bit, 7, 3, 1, BITMAP_EXTRACT_MODE_CELL);


for(int i=0; i<9; i++)
{
		BOB currentBob;
		Clone_BOB(&mainCondie, &currentBob);
		availableCondies.push_back(currentBob);
		Animate_BOB(&mainCondie);
}

Unload_Bitmap_File(&bitmap8bit);

// Initialize base int vector
	for(int i=0; i<availableCondies.size(); i++)
		baseCondiesInt.push_back(0);

// initialize directinput
DInput_Init();

// acquire the keyboard only
DInput_Init_Keyboard();

// initilize DirectSound
DSound_Init();

// load background sounds
//song_id = DSound_Load_WAV("sounds/fd09.wav");
//song_id[1]= DSound_Load_WAV("songs/mess2.WAV");
//song_id[2]= DSound_Load_WAV("songs/mess3.WAV");
//song_id[3]= DSound_Load_WAV("songs/mess5.WAV");
//song_id[4]= DSound_Load_WAV("songs/mess5.WAV");
// start the sounds

//DSound_Play(song_id);

// set clipping rectangle to screen extents so objects dont
// mess up at edges
RECT screen_rect = {0,0,screen_width,screen_height};
lpddclipper = DDraw_Attach_Clipper(lpddsback,1,&screen_rect);

// hide the mouse
//ShowCursor(FALSE);

// return success
return(1);

} // end Game_Init

///////////////////////////////////////////////////////////



int Game_Shutdown(void *parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

// shut everything down

// kill all the bobs

for (int index=0; index < hotdog.size(); index++)
    Destroy_BOB(&hotdog[index]);

Destroy_BOB(&mainHotDog);

// shutdown directdraw last
DDraw_Shutdown();

// now directsound
DSound_Stop_All_Sounds();
DSound_Shutdown();

// shut down directinput
DInput_Shutdown();

// return success
return(1);

} // end Game_Shutdown

//////////////////////////////////////////////////////////
bool checkImpact(int index)
{
	if(index != 0)
		if(Collision_BOBS(&hotdog[index], &hotdog[index-1])) return true;
	

	//for(int j=0; j<hotdog.size(); j++)
	//{
	//	if(j != index && j != 0)
	//	// Check if the current dog is hitting any other dog
	//	{
	//		if(Collision_BOBS(&hotdog[index], &hotdog[index])) return true;
	//	}
	//}
return false;	
}

void animateHotdog()
{
	int index;

	// If there is a dog being wrapped animate it
	// and remove it from the scroll proces
	deleteDog();

	// Move the dogs on the roller
	if(hotdog.size() != 0)
	{
		for(index=0; index < hotdog.size(); index++)
		// animate all dogs on the board
		{
			if(hotdog[index].x < 350 && !checkImpact(index))
			{
				Move_BOB(&hotdog[index]);
				
				// Move all of the dogs condiments
				for(int i=0; i<condies[index].size(); i++)
									Move_BOB(&condies[index][i]);

				// Move all of the attached condiments
				for(int i=0; i<condiesAttached[index].size(); i++)
									Move_BOB(&condiesAttached[index][i]);
				
				if(checkImpact(index) && hotdog.size() == 4) loser = true;
				if(checkImpact(index) || hotdog[index].x >= 350) addNewHotdog();
			}
		}

	}else{
		// add a dog
		addNewHotdog();
	}
}

int Game_Main(void *parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!


if(gameState<7)
{  
	gameState = gameStartUp(gameState);
}

//Draw background then start the song
if (gameState == 7)
{
	int index; // looping var
	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);
	// lock back buffer and copy background into it
	DDraw_Lock_Back_Surface();
	// draw background
	Draw_Bitmap(&background_bmp, back_buffer, back_lpitch,0);
	// unlock back surface
	DDraw_Unlock_Back_Surface();
	//Draw_Text_GDI("Wise Guys Presents:",522, 10,RGB(0,200,200), lpddsback);
	string printedScore = "Score: $";
	printedScore += Convert(score);
	sprintf(buffer,printedScore.c_str());
	Draw_Text_GDI(buffer,522, 10,RGB(0,0,0), lpddsback);
	sprintf(buffer,debug.c_str());
	Draw_Text_GDI(buffer,522, 30,RGB(0,0,0), lpddsback);

	// scroll the background
	//Scroll_Bitmap(&background_bmp, -1);

	// read keyboard
	DInput_Read_Keyboard();

	// Animate the hotdog, and manage inventory
	animateHotdog();

	for (index=hotdog.size()-1; index>=0; index--)
	// Draw the hotdogs
	{
    Draw_Scaled_BOB(&hotdog[index], hotdog[index].varsI[0], hotdog[index].varsI[1],lpddsback);
	for(int i=0; i<condies[index].size(); i++)
		// Draw all of their required condiments	
		Draw_Scaled_BOB(&condies[index][i], condies[index][i].varsI[0], condies[index][i].varsI[1],lpddsback);

	for(int i=0; i<condiesAttached[index].size(); i++)
		// Draw all of their attached condiments	
	Draw_Scaled_BOB(&condiesAttached[index][i], condiesAttached[index][i].varsI[0], condiesAttached[index][i].varsI[1],lpddsback);
}

	//////////////////////////////////////////////////////////////////////////////////////
	//what score to end at? 2.00 is just for testing. I think somewhere between 50-100.00)
	//
	//
	//
	//
	//
	if(loser)
	{
		endGameScreen();
	}
	//
	//
	//
	//
	///////////////////////////////////////////////////////////////////////////////////////



// flip the surfaces
	DDraw_Flip();

// sync to 30 fps = 1/30sec = 33 ms
	Wait_Clock(33);

// check of user is trying to exit
	if (KEY_DOWN(VK_ESCAPE) || keyboard_state[DIK_ESCAPE])
    {
    PostMessage(main_window_handle, WM_DESTROY,0,0);

    // stop all sounds
    DSound_Stop_All_Sounds();

    // do a screen transition
    Screen_Transitions(SCREEN_DARKNESS,NULL,0);
    } // end if
}

//printScore();
// return success
return(1);

} // end Game_Main

//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////

int gameStartUp(int gameState)
{
	static int splashDelay = 150;
	string line="";
	DInput_Read_Keyboard();
	
	if(gameState==0)
	{
	   //lock buffer
	   DDraw_Lock_Primary_Surface();
	   //copy splash image into buffer
	   Draw_Bitmap(&credits_bmp, primary_buffer, primary_lpitch, 0);
	   // unlock surface
	   DDraw_Unlock_Primary_Surface();
	 Sleep(120);
	   splashDelay--;
	   if(KEY_DOWN(VK_SPACE))
	   {
			   gameState=1;
	   }
	}

	// If GAMESTATE=1, show the Title screen
	if(gameState==1)
	{
		   //lock buffer
		   DDraw_Lock_Primary_Surface();
		   //copy splash image into buffer
		   Draw_Bitmap(&lukej_bmp, primary_buffer, primary_lpitch, 0);
		   // unlock surface
		   DDraw_Unlock_Primary_Surface();
		  Sleep(120);
		   if(KEY_DOWN(VK_SPACE))
	   {
			   gameState=2;
	   }
		   
	}
	//IF GAMESTATE=2, show the Highscore screen
	if(gameState==2)
	{
		//lock buffer
		   DDraw_Lock_Primary_Surface();
		   //copy splash image into buffer
		   Draw_Bitmap(&producers_bmp, primary_buffer, primary_lpitch, 0);
		   // unlock surface
		   DDraw_Unlock_Primary_Surface();
		  Sleep(120);
		  if(KEY_DOWN(VK_SPACE))
	   {
			   gameState=3;
	   }
		   
	}

	//IF GAMESTATE=3, show the About screen
	if(gameState==3)
	{
		   //lock buffer
		   DDraw_Lock_Primary_Surface();
		   //copy splash image into buffer
		   Draw_Bitmap(&intro1_bmp, primary_buffer, primary_lpitch, 0);
		   // unlock surface
		   DDraw_Unlock_Primary_Surface();
		   Sleep(120);
		  if(KEY_DOWN(VK_SPACE))
	   {
			   gameState=4;
	   }
	} 

	//IF GAMESTATE=99, show the egg screen
	if(gameState==4)
	{
		    //lock buffer
		   DDraw_Lock_Primary_Surface();
		   //copy splash image into buffer
		   Draw_Bitmap(&intro2_bmp, primary_buffer, primary_lpitch, 0);
		   // unlock surface
		   DDraw_Unlock_Primary_Surface();
		  Sleep(120);
		  if(KEY_DOWN(VK_SPACE))
	   {
			   gameState=5;
	   }
	} 

	if(gameState==5)
	{	
		DSound_Play(1);
		    //lock buffer
		   DDraw_Lock_Primary_Surface();
		   //copy splash image into buffer
		   Draw_Bitmap(&title_bmp, primary_buffer, primary_lpitch, 0);
		   // unlock surface
		   DDraw_Unlock_Primary_Surface();
		   
			 Sleep(120);
		   if(KEY_DOWN(VK_SPACE))
	   {
			   gameState=6;
	   }
	} 
	
	if(gameState==6)
	{	
		    //lock buffer
		   DDraw_Lock_Primary_Surface();
		   //copy splash image into buffer
		   Draw_Bitmap(&instructions_bmp, primary_buffer, primary_lpitch, 0);
		   // unlock surface
		   DDraw_Unlock_Primary_Surface();
		   
			 Sleep(120);
		   if(KEY_DOWN(VK_SPACE))
	   {
			   gameState=7;
	   }
	} 
	return gameState;
}
void endGameScreen()
{
	if(score >= 50.00)
	{
		DDraw_Lock_Back_Surface();
		// draw background
		Draw_Bitmap(&endgameW_bmp, back_buffer, back_lpitch,0);
		// unlock back surface
		DDraw_Unlock_Back_Surface();
		//Draw_Text_GDI(score,300, 257,RGB(71,45,31), lpddsback);
	}
	else
	{
		DDraw_Lock_Back_Surface();
		// draw background
		Draw_Bitmap(&endgameL_bmp, back_buffer, back_lpitch,0);
		// unlock back surface
		DDraw_Unlock_Back_Surface();
		//Draw_Text_GDI(score,300, 257,RGB(71,45,31), lpddsback);
	}
	string printedScore = "Score: $";
	printedScore += Convert(score);
	sprintf(buffer,printedScore.c_str());
	Draw_Text_GDI(buffer,285, 275,RGB(0,0,0), lpddsback);

	Sleep(120);



	if (KEY_DOWN(VK_ESCAPE) || keyboard_state[DIK_ESCAPE])
    {
		PostMessage(main_window_handle, WM_DESTROY,0,0);
		// stop all sounds
		DSound_Stop_All_Sounds();
		// do a screen transition
		Screen_Transitions(SCREEN_DARKNESS,NULL,0);
    } 

	//DDraw_Flip();
}